/*
 * $Id: networkprefs.c,v 1.4 2007/02/12 19:35:47 laire Exp $
 */
#define AROS_ALMOST_COMPATIBLE
#include "global.h"

#define DEBUG 0
#include <aros/debug.h>

BOOL CheckForNetstack(void)
{
BOOL HaveNetStack=FALSE;
struct Process *me = (struct Process *) FindTask(NULL);
APTR oldwinptr = me->pr_WindowPtr;
BPTR MyLock;

	D(bug("%s:\n",__func__));

	me->pr_WindowPtr = (APTR) -1;

	if ((MyLock = Lock("s:network-startup", ACCESS_READ)))
	{
		UnLock(MyLock);
		HaveNetStack = TRUE;
		D(bug("%s: success\n",__func__));
	}
	else
	{
		D(bug("%s: failed \n",__func__));
	}
	me->pr_WindowPtr = oldwinptr;
	return(HaveNetStack);
}

/*********************************************************************************************/

void LoadNetworkPrefs(char *filename)
{
	D(bug("%s: <%s>\n",__func__,filename));

	if (CheckForNetstack())
	{
		BPTR ifh, ofh;

		D(bug("%s: <s:network-startup> exists, use it\n",__func__));

		ifh = Open("NIL:", MODE_OLDFILE);
		ofh = Open("NIL:", MODE_NEWFILE);
		if (ifh && ofh)
		{
			#if 1
			if (SystemTags("execute s:network-startup",
			               SYS_Asynch, TRUE,
			               SYS_Input, ifh,
			               SYS_Output, ofh,
			               TAG_END) != -1)
			{
				ifh = 0;
				ofh = 0;
			}
			#else
			SystemTags("execute s:network-startup",
			           SYS_Asynch, TRUE,
			           SYS_Input, NULL,
			           SYS_Output, NULL,
			           TAG_END);
			#endif

			D(bug("%s: SystemTags() returned\n",__func__));
		}

		if (ofh)
		{
			Close(ofh);
		}

		if (ifh)
		{
			Close(ifh);
		}
	}
	else
	{
		D(bug("%s: NetStack disabled\n",__func__));
	}
}

/*********************************************************************************************/

void StartNetwork(void)
{
struct Process *me = (struct Process *) FindTask(NULL);
APTR oldwinptr = me->pr_WindowPtr;
BPTR MyLock;

	D(bug("%s:\n",__func__));

	me->pr_WindowPtr = (APTR) -1;

	if ((MyLock = Lock("env:sys/interface.prefs", ACCESS_READ)))
	{
		UnLock(MyLock);
		D(bug("%s: config file found, network will be started async\n",__func__));
	}
	else
	{
		D(bug("%s: no config file found, start network direct\n",__func__));
		LoadNetworkPrefs(NULL);
	}
	me->pr_WindowPtr = oldwinptr;
}
